/*===============================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: *********************************** //
/*===============================================================================================================*/
// CHEROKEE LAND:
// CREATED BY DANY:
// MAY 2007:
/*===============================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ********************************** //
/*===============================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*===============================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1; 
		
		if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");

		subCiv3=rmGetCivID("Cherokee");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Cherokee");
   }	

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*===============================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ******************************************** //
/*===============================================================================================================*/

   	    int playerTiles=17500;
   
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*===============================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*===============================================================================================================*/

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(0.0);

        // SET MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.02, 7, 0.5, 8.0);
	
	    // SET BASE TERRAIN MIX:
	    rmSetBaseTerrainMix("great plains drygrass");
	
	    // TERRAIN INITIALIZATION:
		rmTerrainInitialize("yukon\ground1_yuk", 5);
	
	    // SET LIGHTING:
		rmSetLightingSet("great plains");
	
	    // SET MAP TYPE:
	    rmSetMapType("greatPlains");
	    rmSetMapType("land");
		rmSetMapType("grass");
	
	    // SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("classPatch");
	    rmDefineClass("starting settlement");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("secrets");
	    rmDefineClass("natives");	
	    rmDefineClass("classHillArea");
	    rmDefineClass("SocketClass");
	    rmDefineClass("nuggets");
		rmDefineClass("classCliff");
		rmDefineClass("region");
		rmDefineClass("classWall");
				
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*===============================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ****************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

        // PLAYER CONSTRAINTS:
        int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 15.0);
        int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
        int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", classPlayer, 40.0);

		// Cardinal Directions
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
				
        // RESOURCE AVOIDANCE:
        int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
        int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
        int avoidBison=rmCreateTypeDistanceConstraint("bison avoids food", "bison", 40.0);
        int avoidPronghorn=rmCreateTypeDistanceConstraint("pronghorn avoids food", "pronghorn", 35.0);
	    int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
	    int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 22.0);
        
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
        int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);

	    int avoidFastCoin=-1;
	    if (cNumberNonGaiaPlayers >6)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.12));
	}
	    else if (cNumberNonGaiaPlayers >4)
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.14));
	}
	    else
	{
		avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", rmXFractionToMeters(0.16));
	}

        // AVOID IMPASSABLE LAND:
        int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
        int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
        int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

        // UNIT AVOIDANCE: - FOR THINGS THAT ARE'T IN THE STARTING RESOURCES:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);

        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
				
		// CLIFF AVOIDANCE:
		int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
	    int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 10.0);
	    int avoidCloseCliff=rmCreateClassDistanceConstraint("close vs. cliff", rmClassID("classCliff"), 2.0);
		
		// REGIONS AVOIDANCE:
		int avoidRegion=rmCreateClassDistanceConstraint("stay away from region", rmClassID("region"), 8.0);
	    int avoidCloseRegion=rmCreateClassDistanceConstraint("close away from region", rmClassID("region"), 2.0);
		
		// WALL CONSTRAINT:
		int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 10.0);
	    int avoidCloseWall=rmCreateClassDistanceConstraint("close avoids wall", rmClassID("classWall"), 2.0);
	   	   		
        // VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
        int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
        //int avoidTradeRoutePlayer = rmCreateTradeRouteDistanceConstraint("trade route player", 30.0);
        int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);

	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 8.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("SocketClass"), 2.0);
	    int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("SocketClass"), 15.0);

        // CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater40 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 40.0);
		
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 8.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 35.0);
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);

	    // AVOID THE HILLY AREAS:
	    int avoidHills = rmCreateClassDistanceConstraint("avoid Hills", rmClassID("classHillArea"), 5.0);
	
	    // NATIVES AVOID NATIVES:
	    int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 40.0);
	    int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 20.0);

	    // CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*===============================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE: *************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

              // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.175, 0.825);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.375, 0.625);
	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
/*================================================================================================================*/
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 2:
	  int tradeRoute2ID = rmCreateTradeRoute();
      socketID=rmCreateObjectDef("sockets to dock Trade Posts north");
      rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.825, 0.175);
	  rmAddTradeRouteWaypoint(tradeRoute2ID, 0.625, 0.375);
	  
      placedTradeRoute = rmBuildTradeRoute(tradeRoute2ID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 2:
      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRoute2ID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();
	
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE REGION AREAS: ************************************* //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

		int region1ID=rmCreateArea("region 1");
	    // rmSetAreaSize(region1ID, 0.03, 0.03);
		rmSetAreaSize(region1ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
	    rmSetAreaCoherence(region1ID, 1.0);
	    rmAddAreaToClass(region1ID, rmClassID("region"));
		//rmSetAreaMix(region1ID, "rockies_snow");
		rmAddAreaConstraint(region1ID, avoidRegion); 
        rmAddAreaConstraint(region1ID, avoidCloseRegion);
		rmSetAreaLocation(region1ID, 0.66, 0.66);
        rmBuildArea(region1ID);	

        int region2ID=rmCreateArea("region 2");
		rmSetAreaSize(region2ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
	    // rmSetAreaSize(region2ID, 0.03, 0.03);
	    rmSetAreaCoherence(region2ID, 1.0);
	    rmAddAreaToClass(region2ID, rmClassID("region"));
		//rmSetAreaMix(region2ID, "rockies_snow");
		rmAddAreaConstraint(region2ID, avoidRegion); 
        rmAddAreaConstraint(region2ID, avoidCloseRegion);
		rmSetAreaLocation(region2ID, 0.34, 0.34);
        rmBuildArea(region2ID);		

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*===============================================================================================================*/
// ****************************************** DEFINE ALL THE AREAS: ******************************************** //
/*===============================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*===============================================================================================================*/
        
		if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.775,0.775);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.225,0.225);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	} 
	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*===============================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*===============================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
	    rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
	    rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
	    rmAddAreaConstraint(id, avoidTradeRoute); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();
   
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*===============================================================================================================*/
// ************************************ SOME VARIABLES TO BE USED LATER: *************************************** //   
/*===============================================================================================================*/
/*
	int numTries = -1;
	int failCount = -1;
*/	
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE TWO HILLY AREAS: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*===============================================================================================================*/
// PLACEMENT ORDER OF NON-TRADE ROUTE STUFF:
// NATIVES -> SECRETS -> NUGGETS -> SMALL PONDS (WHEE):
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*===============================================================================================================*/
// *************************** DEFINE THE STARTING UNITS AND STARTING RESOURCES DEFS: ************************** //
/*===============================================================================================================*/
	
	    // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 9.0);
	    rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	    // rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*---------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 16.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 22.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING BISONS:
		int StartBisonID=rmCreateObjectDef("starting bison");
	    rmAddObjectDefItem(StartBisonID, "Bison", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBisonID, 14.0);
	    rmSetObjectDefMaxDistance(StartBisonID, 18.0);
	    rmSetObjectDefCreateHerd(StartBisonID, true);
	    rmAddObjectDefConstraint(StartBisonID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGETS:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	    // DEFINE SOME VARIABLES FOR THE SILVER MINES:
		int silverType = -1;
	    int playerGoldID = -1;
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*===============================================================================================================*/
// ********************* PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES:	******************** //	
/*===============================================================================================================*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		// vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		// rmSetHomeCityGatherPoint(i, closestPoint);

		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	}

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*===============================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE AMERICANS: *********************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.40, 0.80);
	}  
	
	    if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.80, 0.40);
	} 
	
	    if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.60, 0.20);
	} 
	
	    if (subCiv3 == rmGetCivID("cherokee"))
	{  
		int cherokee4VillageID = -1;
		cherokee4VillageID = rmCreateGrouping("cherokee village 4", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee4VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee4VillageID, 0.0);
		rmAddGroupingToClass(cherokee4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee4VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee4VillageID, 0, 0.20, 0.60);
	} 

/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*===============================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
   
        int numTries=cNumberNonGaiaPlayers*0.5;
   
        for(i=0; <numTries)
   {
        int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "Great Plains");
	    // rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliffID, 2, 0.4, 0.1, 1.0, 0);
        rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, cliffConstraint);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.66, 0.66);
        rmBuildArea(cliffID);
   } 
   
/*---------------------------------------------------------------------------------------------------------------*/

        for(i=0; <numTries)
   {
        int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
        rmSetAreaWarnFailure(cliff2ID, false);
		rmSetAreaCliffType(cliff2ID, "Great Plains");
	    // rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(cliff2ID, 2, 0.4, 0.1, 1.0, 0);
	    rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, -6, 1.0, 1.0);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, cliffConstraint);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.34, 0.34);
        rmBuildArea(cliff2ID);
   }   

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TREASURES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.30, 0.50);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.50, 0.30);
		
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.50, 0.70);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.70, 0.50);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.025, 0.45);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.025);
		
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.55, 0.965);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.965, 0.55);	

/*---------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.05, 0.65);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.65, 0.05);
		
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.35, 0.95);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.95, 0.35);				
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*===============================================================================================================*/
// *************************************** DEFINE AND PLACE THE PONDS: ***************************************** //
/*===============================================================================================================*/

	    // PONDS O' FUN:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 25.0);

/*---------------------------------------------------------------------------------------------------------------*/
        
        int smallPond1ID=rmCreateArea("small pond 1");
        rmSetAreaSize(smallPond1ID, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
        rmSetAreaWaterType(smallPond1ID, "London");
        rmSetAreaBaseHeight(smallPond1ID, 4);
        rmSetAreaMinBlobs(smallPond1ID, 1);
        rmSetAreaMaxBlobs(smallPond1ID, 1);
        rmSetAreaMinBlobDistance(smallPond1ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond1ID, 1.0);
        rmAddAreaToClass(smallPond1ID, pondClass);
        rmSetAreaCoherence(smallPond1ID, 0.95);
        rmSetAreaSmoothDistance(smallPond1ID, 5);
        rmAddAreaConstraint(smallPond1ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond1ID, false);
		rmSetAreaLocation(smallPond1ID, 0.55, 0.85);
        rmBuildArea(smallPond1ID);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond2ID=rmCreateArea("small pond 2");
        rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
        rmSetAreaWaterType(smallPond2ID, "London");
        rmSetAreaBaseHeight(smallPond2ID, 4);
        rmSetAreaMinBlobs(smallPond2ID, 1);
        rmSetAreaMaxBlobs(smallPond2ID, 1);
        rmSetAreaMinBlobDistance(smallPond2ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond2ID, 1.0);
        rmAddAreaToClass(smallPond2ID, pondClass);
        rmSetAreaCoherence(smallPond2ID, 0.95);
        rmSetAreaSmoothDistance(smallPond2ID, 5);
        rmAddAreaConstraint(smallPond2ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond2ID, false);
		rmSetAreaLocation(smallPond2ID, 0.85, 0.55);
        rmBuildArea(smallPond2ID);

/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond3ID=rmCreateArea("small pond 3");
        rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
        rmSetAreaWaterType(smallPond3ID, "London");
        rmSetAreaBaseHeight(smallPond3ID, 4);
        rmSetAreaMinBlobs(smallPond3ID, 1);
        rmSetAreaMaxBlobs(smallPond3ID, 1);
        rmSetAreaMinBlobDistance(smallPond3ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond3ID, 1.0);
        rmAddAreaToClass(smallPond3ID, pondClass);
        rmSetAreaCoherence(smallPond3ID, 0.95);
        rmSetAreaSmoothDistance(smallPond3ID, 5);
        rmAddAreaConstraint(smallPond3ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond3ID, false);
		rmSetAreaLocation(smallPond3ID, 0.45, 0.15);
        rmBuildArea(smallPond3ID);

/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond4ID=rmCreateArea("small pond 4");
        rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(2000), rmAreaTilesToFraction(2000));
        rmSetAreaWaterType(smallPond4ID, "London");
        rmSetAreaBaseHeight(smallPond4ID, 4);
        rmSetAreaMinBlobs(smallPond4ID, 1);
        rmSetAreaMaxBlobs(smallPond4ID, 1);
        rmSetAreaMinBlobDistance(smallPond4ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond4ID, 1.0);
        rmAddAreaToClass(smallPond4ID, pondClass);
        rmSetAreaCoherence(smallPond4ID, 0.95);
        rmSetAreaSmoothDistance(smallPond4ID, 5);
        rmAddAreaConstraint(smallPond4ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond4ID, false);
		rmSetAreaLocation(smallPond4ID, 0.15, 0.45);
        rmBuildArea(smallPond4ID);	

/*---------------------------------------------------------------------------------------------------------------*/

        int smallPond5ID=rmCreateArea("small pond 5");
        rmSetAreaSize(smallPond5ID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
        rmSetAreaWaterType(smallPond5ID, "London");
        rmSetAreaBaseHeight(smallPond5ID, 4);
        rmSetAreaMinBlobs(smallPond5ID, 1);
        rmSetAreaMaxBlobs(smallPond5ID, 1);
        rmSetAreaMinBlobDistance(smallPond5ID, 1.0);
        rmSetAreaMaxBlobDistance(smallPond5ID, 1.0);
        rmAddAreaToClass(smallPond5ID, pondClass);
        rmSetAreaCoherence(smallPond5ID, 0.95);
        rmSetAreaSmoothDistance(smallPond5ID, 5);
        rmAddAreaConstraint(smallPond5ID, pondConstraint);
        rmSetAreaWarnFailure(smallPond5ID, false);
		rmSetAreaLocation(smallPond5ID, 0.50, 0.50);
        rmBuildArea(smallPond5ID);			
     
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE COIN RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.66, 0.66);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.34, 0.34);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.25, 0.65);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.25);
		
        rmPlaceObjectDefAtLoc(gold2ID, 0, 0.35, 0.75);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.75, 0.35);
		
/*---------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.35, 0.05);
		
        rmPlaceObjectDefAtLoc(gold3ID, 0, 0.65, 0.95);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.95, 0.65);		

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "bison", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.30, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.60, 0.30);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.70, 0.40);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.40, 0.70);	

/*---------------------------------------------------------------------------------------------------------------*/

        int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "bison", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.30, 0.10);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.70, 0.90);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.90, 0.70);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int deer3ID=rmCreateObjectDef("The Deer Herds 3");
        rmAddObjectDefItem(deer3ID, "bison", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(deer3ID, 0.0);
        rmSetObjectDefMaxDistance(deer3ID, 0.0);
	    rmAddObjectDefConstraint(deer3ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer3ID, true);
	    
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.15, 0.75);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.75, 0.15);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(deer3ID, 0, 0.85, 0.25);		

/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.15, 0.65);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.65, 0.15);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.35, 0.85);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.85, 0.35);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.25, 0.35);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.35, 0.25);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.65, 0.75);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.75, 0.65);		

/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE COWS: ********************************************* //
/*================================================================================================================*/ 
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.05);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.45, 0.95);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.95, 0.45);
		
/*---------------------------------------------------------------------------------------------------------------*/

        int cow2ID=rmCreateObjectDef("The Cows 2");
        rmAddObjectDefItem(cow2ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow2ID, 0.0);
        rmSetObjectDefMaxDistance(cow2ID, 0.0);
	    rmAddObjectDefConstraint(cow2ID, avoidCow);
		rmSetObjectDefCreateHerd(cow2ID, true);
	    
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.30, 0.45);
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.45, 0.30);
        
		rmPlaceObjectDefAtLoc(cow2ID, 0, 0.55, 0.70);
        rmPlaceObjectDefAtLoc(cow2ID, 0, 0.70, 0.55);		
		
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE THE PERCHING VULTURES: ********************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int vultureID=rmCreateObjectDef("perching vultures");
	    int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	    rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	    rmSetObjectDefMinDistance(vultureID, 0.0);
	    rmSetObjectDefMaxDistance(vultureID, 0.0);
	    rmAddObjectDefConstraint(vultureID, avoidVultures);
	    
	    rmPlaceObjectDefAtLoc(vultureID, 0, 0.25, 0.55);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.55, 0.25);
		
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(vultureID, 0, 0.75, 0.45);
		
/*===============================================================================================================*/
/*===============================================================================================================*/
// ************************************ DEFINE AND PLACE SOME ROCK WALLS: ************************************** //
/*===============================================================================================================*/

	    int stoneWallType = -1;
	    int stoneWallID = -1;
	    int stoneWallCount = cNumberNonGaiaPlayers*2;	
	    rmEchoInfo("stoneWall count = "+stoneWallCount);

	    for(i=0; < stoneWallCount)
   {
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, 0.0);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.20, 0.70);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.70, 0.20);
		
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.30, 0.80);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.80, 0.30);
   }
		
				
/*===============================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: ************************************** //
/*===============================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/
		
		int forestTreeID = 0;
        numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("The Forest 1"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest, "great plains forest");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, avoidRegion);
		rmAddAreaConstraint(forest, avoidNatives);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, avoidNuggetSmall);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*---------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("The Forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(175), rmAreaTilesToFraction(175));
        rmSetAreaForestType(forest2, "great plains forest");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, playerConstraint);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        rmAddAreaConstraint(forest2, avoidRegion);
		rmAddAreaConstraint(forest2, avoidNatives);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, avoidNuggetSmall);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    } 
	/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE WHALE: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
	    if(rmRandFloat(0,1) < 0.5)
   {
		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
   }
*/   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ***************************************** // 
/*===============================================================================================================*/
 

	
		